unit CTS.Entities.Com.Plants;

interface

uses
  SysUtils, 
  Generics.Collections, 
  Aurelius.Mapping.Attributes, 
  Aurelius.Types.Blob, 
  Aurelius.Types.DynamicProperties, 
  Aurelius.Types.Nullable, 
  Aurelius.Types.Proxy, 
  Aurelius.Dictionary.Classes, 
  Aurelius.Linq,

  CTS.Entities.SEQ.CrAt_UpAt;

type
  Tcom_plants = class;
  Tcom_plantsDictionary = class;
  
  [Entity]
  [Table('com_plants')]
  [Id('Fid', TIdGenerator.IdentityOrSequence)]
  Tcom_plants = class(TSeqEntity)
  private
    [Column('id', [TColumnProp.Required, TColumnProp.NoInsert, TColumnProp.NoUpdate])]
    Fid: Integer;
    
    [Column('name', [], 127)]
    Fname: Nullable<string>;
    
    [Column('nameShort', [], 15)]
    FnameShort: Nullable<string>;
    
    [Column('nameCode', [], 7)]
    FnameCode: Nullable<string>;
    
    [Column('address', [], 511)]
    Faddress: Nullable<string>;
    
    [Column('isActive', [])]
    FisActive: Nullable<Integer>;
(*
  These were first auto-created using Aurelius connection
  with "generate entities from database..." - then removed once
  unit CTS.Entities.SEQ.CrAt_UpAt was included

    [Column('createdAt', [TColumnProp.Required])]
    FcreatedAt: TDateTime;

    [Column('updatedAt', [TColumnProp.Required])]
    FupdatedAt: TDateTime;
*)
  public
    property id: Integer read Fid write Fid;
    property name: Nullable<string> read Fname write Fname;
    property nameShort: Nullable<string> read FnameShort write FnameShort;
    property nameCode: Nullable<string> read FnameCode write FnameCode;
    property address: Nullable<string> read Faddress write Faddress;
    property isActive: Nullable<Integer> read FisActive write FisActive;
(*
    property createdAt: TDateTime read FcreatedAt write FcreatedAt;
    property updatedAt: TDateTime read FupdatedAt write FupdatedAt;
*)
  end;
  
  Icom_plantsDictionary = interface;
  
  Icom_plantsDictionary = interface(IAureliusEntityDictionary)
    function id: TLinqProjection;
    function name: TLinqProjection;
    function nameShort: TLinqProjection;
    function nameCode: TLinqProjection;
    function address: TLinqProjection;
    function isActive: TLinqProjection;
    function createdAt: TLinqProjection;
    function updatedAt: TLinqProjection;
  end;
  
  Tcom_plantsDictionary = class(TAureliusEntityDictionary, Icom_plantsDictionary)
  public
    function id: TLinqProjection;
    function name: TLinqProjection;
    function nameShort: TLinqProjection;
    function nameCode: TLinqProjection;
    function address: TLinqProjection;
    function isActive: TLinqProjection;
    function createdAt: TLinqProjection;
    function updatedAt: TLinqProjection;
  end;
  
  IDictionary = interface(IAureliusDictionary)
    function com_plants: Icom_plantsDictionary;
  end;
  
  TDictionary = class(TAureliusDictionary, IDictionary)
  public
    function com_plants: Icom_plantsDictionary;
  end;
  
function Dic: IDictionary;

implementation

var
  __Dic: IDictionary;

function Dic: IDictionary;
begin
  if __Dic = nil then __Dic := TDictionary.Create;
  result := __Dic;
end;

{ Tcom_plantsDictionary }

function Tcom_plantsDictionary.id: TLinqProjection;
begin
  Result := Prop('id');
end;

function Tcom_plantsDictionary.name: TLinqProjection;
begin
  Result := Prop('name');
end;

function Tcom_plantsDictionary.nameShort: TLinqProjection;
begin
  Result := Prop('nameShort');
end;

function Tcom_plantsDictionary.nameCode: TLinqProjection;
begin
  Result := Prop('nameCode');
end;

function Tcom_plantsDictionary.address: TLinqProjection;
begin
  Result := Prop('address');
end;

function Tcom_plantsDictionary.isActive: TLinqProjection;
begin
  Result := Prop('isActive');
end;

function Tcom_plantsDictionary.createdAt: TLinqProjection;
begin
  Result := Prop('createdAt');
end;

function Tcom_plantsDictionary.updatedAt: TLinqProjection;
begin
  Result := Prop('updatedAt');
end;

{ TDictionary }

function TDictionary.com_plants: Icom_plantsDictionary;
begin
  Result := Tcom_plantsDictionary.Create;
end;

initialization
  RegisterEntity(Tcom_plants);

end.
